
name = "M8 washer segment"; // for MuJoCo commands in console window
id = 8.4; // inner diameter in mm
od = 16; // outer diameter in mm
t = 1.6; // thickness in mm
$fn = 36; // facets number
tab = "&nbsp; &nbsp; &nbsp; "; // xml result for MuJoCo in Console window
// after copying & pasting, search & replace ECHO: " by an empty string

module puts(s) {
  echo(str("<b>", s, "</b>ECHO: "));
}

puts(str("&lt;asset&gt;"));
puts(str(tab, "&lt;mesh file=\"", name, ".stl\" scale=\".001 .001 .001\" /&gt;"));
puts(str("&lt;/asset&gt;"));
puts(str("&lt;body name=\"washer\" childclass=\"steel\" pos=\"0 0 0\"&gt;"));
puts(str(tab, "&lt;joint type=\"free\" /&gt;"));
puts(str(tab, "&lt;geom class=\"washer sheet\" mass=\"1e-9\" size=\"", od / 2000, " ", od / 2000, " ", t / 2000, "\" pos=\"0 0 ", t / 2000, "\" />"));
for (a = [0 : 30 : 359]) puts(str(tab, "&lt;geom ",
  "class=\"washer segment\" ",
  "mesh=\"", name, "\" ",
  "pos=\"0 0 0\" ",
  "euler=\"0 0 ", a, "\" />"
));
puts(str(tab, "&lt;!--spacer balls reduce number of contacts--&gt;"));
n = 8;
for (i = [0 : n - 1]) puts(str(tab, "&lt;geom ",
  "class=\"washer spacer\" ",
  //"name=\"washer spacer ", i, "\" ",
  "size=\".0002\" ",
  "pos=\"", od / 2 * cos(i * 360 / n) * .001, " ", od / 2 * sin(i * 360 / n) * .001, " ", i % 2 * t * .001, "\" /&gt;"
));
puts(str("&lt;/body&gt;"));

difference() {
  cylinder(d = od, h = t);
  cylinder(d = id, h = t);
  translate([-od, -od]) cube([od * 2, od, t]);
  rotate([0, 0, 30]) translate([-od, 0]) cube([od * 2, od, t]);
}
