
#include "(Precompiled Headers).h"

#include "1 stuff.h"

HWND Haptix_window;
BOOL CALLBACK Find_haptix_window(HWND hwnd, LPARAM) {
  char title[20];
  if (GetWindowTextA(hwnd, title, sizeof(title)) && strncmp(title, "MuJoCo HAPTIX", 13) == 0) {
    Haptix_window = hwnd;
    return false;
  }
  return true;
}
unsigned _stdcall Watchdog(void*) {
  while (IsWindow(Haptix_window)) Sleep(200);
  _log("Watchdog exit");
  exit(1);
  return 0;
}
int ps;
int loop;
string combination_name;
bool capture_image_sequence = false;

#include "2 nut.h"
NUT nut;

#include "3 parameter_search.h"
PARAMETER_SEARCH parameter_search;

int APIENTRY wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {
  string error;
  HANDLE watchdog = INVALID_HANDLE_VALUE;
  try {
    verify(SetCurrentDirectory(GetProgramDirectory("")));
    EnumWindows(Find_haptix_window, 0);
    if (Haptix_window) {
      SwitchToThisWindow(Haptix_window, true);
#ifdef _DEBUG
    } else if (WinExec("\"H:\\mjhaptix131\\program\\mjhaptix.exe\" -nomocap", capture_image_sequence ? SW_SHOWNORMAL : SW_SHOWMAXIMIZED) >= 32) {
      EnumWindows(Find_haptix_window, 0);
      verify(Haptix_window);
      PostMessage(Haptix_window, WM_COMMAND, 1000, 0);
      int wait = 3000 / 100;
      while (!GetWindow(Haptix_window, GW_CHILD) && wait--) Sleep(100);
      HWND canvas;
      verify(canvas = GetWindow(Haptix_window, GW_CHILD));
      //PostMessage(canvas, WM_KEYDOWN, VK_F4, 0);
      //PostMessage(canvas, WM_KEYDOWN, VK_SPACE, 0);
      PostMessage(canvas, WM_KEYDOWN, 'T', 0);
      PostMessage(canvas, WM_KEYDOWN, 'C', 0);
      PostMessage(canvas, WM_KEYDOWN, 'F', 0);
      PostMessage(canvas, WM_KEYDOWN, 'P', 0);
      PostMessage(canvas, WM_KEYDOWN, '2', 0);
      //PostMessage(canvas, WM_KEYDOWN, '3', 0);
      PostMessage(canvas, WM_KEYDOWN, '4', 0);
#endif
    } else throw string("Cannot find MuJoCo HAPTIX window");
    verify((watchdog = (HANDLE)_beginthreadex(NULL, 4096, Watchdog, NULL, STACK_SIZE_PARAM_IS_A_RESERVATION, NULL)) != INVALID_HANDLE_VALUE);
    MJ(mj_connect(NULL));
    bool hotkeys_enabled = false;
    while (IsWindow(Haptix_window)) {
      mjInfo info;
      MJ(mj_info(&info));
      if (memcmp(&info, &nut.info, offsetof(mjInfo, timestep)) != 0) {
        verify(info.nbody > 0);
        nut.info = info;
        nut.ob.bodyid = 0;
        nut.find(+1);
      }
      const UINT hotkeys[] = {VK_ESCAPE, VK_UP, VK_DOWN, VK_PRIOR, VK_NEXT, CTRL + 'C', CTRL + 'P'};
      if (GetForegroundWindow() == Haptix_window) {
        if (!hotkeys_enabled) {
          for_(i, _countof(hotkeys)) verify(RegisterHotKey(NULL, i, HIWORD(hotkeys[i]), LOWORD(hotkeys[i])));
          hotkeys_enabled = true;
        }
        nut.turn = (GetAsyncKeyState(VK_LEFT) < 0) - (GetAsyncKeyState(VK_RIGHT) < 0);
        nut.hold = (GetAsyncKeyState(VK_SHIFT) < 0);
      } else {
        if (hotkeys_enabled) {
          for_(i, _countof(hotkeys)) verify(UnregisterHotKey(NULL, i));
          hotkeys_enabled = false;
        }
      }
      MSG msg;
      if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
        if (msg.message == WM_HOTKEY) switch (LOWORD(msg.lParam) << 16 | HIWORD(msg.lParam)) {
        case VK_ESCAPE: _log("Escape exit"); return 0;
        case VK_UP: nut.find(-1); break;
        case VK_DOWN: nut.find(+1); break;
        case VK_PRIOR: nut.max_torque += .5; break;
        case VK_NEXT: nut.max_torque = lbound(.5, nut.max_torque - .5); break;
        case CTRL + 'C': nut.copy_position_to_clipboard(); break;
        case CTRL + 'P': parameter_search.on_off(); break;
        }
      }
      if (ps) ps = parameter_search.update();
      if (capture_image_sequence) nut.turn = -1;
      nut.update();
      if (capture_image_sequence) {
        Sleep(20);
        Send(CTRL + VK_F11); // IrfanView
        Sleep(50);
      }
    }
    _log("!IsWindow exit");
    return 0;
  } catch (string& s) {
    error = s;
  } catch (exception& e) {
    error = e.what();
  }
  TerminateThread(watchdog, 0);
  _log("%s", error.c_str());
  Sleep(100);
  if (IsWindow(Haptix_window) || mj_result() != mjCOM_CANNOTRECV) {
    MessageBoxA(Haptix_window, error.c_str(), "Nuts and Bolts Tool for HAPTIX", MB_ICONERROR | MB_OK);
  }
  _log("Catch exit");
  return 1;
}
